package anywheresoftware.b4a.objects;

import android.view.ViewGroup;
import android.widget.CompoundButton;
import android.widget.Switch;
import android.widget.CompoundButton.OnCheckedChangeListener;
import anywheresoftware.b4a.BA;
import anywheresoftware.b4a.BA.Events;
import anywheresoftware.b4a.BA.Hide;
import anywheresoftware.b4a.BA.Pixel;
import anywheresoftware.b4a.BA.ShortName;
import anywheresoftware.b4a.BALayout;
import anywheresoftware.b4a.keywords.Common.DesignerCustomView;

@ShortName("Switch")
@Events(values={"CheckedChange (Value As Boolean)"})
public class SwitchWrapper implements DesignerCustomView {
	private BA ba;
	private String eventName;
	private Switch switchView;

	public void Initialize(BA ba, String EventName, int InitProperty1, boolean InitProperty2) {
		_initialize(ba, null, EventName);
	}

	@Hide
	public void _initialize(BA ba, Object activityClass, String EventName) {
		this.eventName = EventName.toLowerCase(BA.cul);
		this.ba = ba;
	}

	//programmatically add view
	public void AddToParent(ViewGroup Parent, @Pixel int left, @Pixel int top, @Pixel int width, @Pixel int height) {
		switchView = new Switch(ba.context);
		switchView.setOnCheckedChangeListener(new OnCheckedChangeListener() {

			@Override
			public void onCheckedChanged(CompoundButton arg0, boolean arg1) {
				ba.raiseEvent(this, eventName + "_checkedchange", arg1);
			}

		});
		Parent.addView(switchView, new BALayout.LayoutParams(left, top, width, height));
	}
	//this method cannot be hidden.
	public void DesignerCreateView(PanelWrapper base, LabelWrapper lw, anywheresoftware.b4a.objects.collections.Map props) {
		ViewGroup vg = (ViewGroup) base.getObject().getParent();
		AddToParent(vg, base.getLeft(), base.getTop(), base.getWidth(), base.getHeight());
		base.RemoveView();
		//set text properties
		switchView.setText(lw.getText());
		switchView.setTypeface(lw.getTypeface());
		switchView.setTextSize(lw.getTextSize());
		switchView.setTextColor(lw.getTextColor());

	}
	public void setChecked(boolean value) {
		switchView.setChecked(value);
	}
	public boolean getChecked() {
		return switchView.isChecked();
	}

	public void setLeft(int left)
	{
		BALayout.LayoutParams lp = (BALayout.LayoutParams)switchView.getLayoutParams();
		lp.left = left;
		switchView.getParent().requestLayout();
	}
	public int getLeft()
	{
		BALayout.LayoutParams lp = (BALayout.LayoutParams)switchView.getLayoutParams();
		return lp.left;
	}
	public void setTop(int top)
	{
		BALayout.LayoutParams lp = (BALayout.LayoutParams)switchView.getLayoutParams();
		lp.top = top;
		switchView.getParent().requestLayout();
	}
	public int getTop()
	{
		BALayout.LayoutParams lp = (BALayout.LayoutParams)switchView.getLayoutParams();
		return lp.top;
	}

}